import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.text.DecimalFormat;
import java.util.ArrayList;

public class MakeWPGMATree {
    
    final int INDEX_ = 100000000;
    
    public static void fileWriter(String msg,boolean ln,String name,String code){
        
        File file = new File(name);
        if (!file.exists()){
            try {
                file.createNewFile();
            } catch (IOException e) {
            }
        }
        
        try {
            FileOutputStream fos = new FileOutputStream(name,true);
            OutputStreamWriter osw = new OutputStreamWriter(fos , code);
            BufferedWriter bw = new BufferedWriter(osw);
            bw.write(msg);
            
            if(ln){
                bw.write("\n");
            }
            
            bw.close();
            osw.close();
            fos.close();
            
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void test(String hat2Name, boolean disList, boolean disMat, boolean disSum, boolean disBra, boolean disTree, boolean disName, boolean output){
        ArrayList<String> listName = new ArrayList<String>();
        ArrayList<String> listDist = new ArrayList<String>();
        ArrayList<String> column = new ArrayList<String>();
        int numSp = 0;
        
        try {
            FileReader in = new FileReader(hat2Name);
            BufferedReader br = new BufferedReader(in);
            String line;
            int counterL = 0;
            int counterN = 0;
            
            while ((line = br.readLine()) != null) {
                if(counterL == 0 || counterL == 2){
                }else if(counterL == 1){
                    String[] temp = line.replaceAll("[\\s]+", ",").split(",");
                    numSp = Integer.parseInt(temp[1]);
                    counterN = numSp - 1;
                }else if(counterL <= numSp + 2){
                    String[] temp = line.split("=");
                    listName.add(temp[1].replaceAll("\\(", "<").replaceAll("\\)", ">").replaceAll(",", "_"));
                }else {
                    String[] temp = line.replaceAll("[\\s]+", ",").split(",");
                    
                    for(int i = 1 ; i < temp.length ; i++){
                        column.add(temp[i]);
                    }
                    
                    if(counterN == column.size()){
                        String col = "";
                        
                        for(String str : column){
                            col += "," + str;
                        }
                        
                        listDist.add(col);
                        counterN--;
                        column.clear();
                    }
                }
                
                counterL++;
            }
            
            br.close();
            in.close();
            
        } catch (IOException e) {
            System.out.println(e);
        }
        
        int order = (int)Math.log10(listName.size()) + 1;
        
        if(disList){
            System.out.println("### List of OTUs ###");
            System.out.println();
            
            if(output){
                fileWriter("### List of OTUs ###\n", true, hat2Name + ".txt", "UTF-8");
            }
            
            for(int i = 0 ; i < listName.size() ; i++){
                
                System.out.println(String.format("%" + order + "s", (i + 1)) + ".=" + listName.get(i));
                
                if(output){
                    fileWriter(String.format("%" + order + "s", (i + 1)) + ".=" + listName.get(i), true, hat2Name + ".txt", "UTF-8");
                }
            }
            
            System.out.println();
            
            if(output){
                fileWriter("", true, hat2Name + ".txt", "UTF-8");
            }
        }
        
        if(disMat || disSum || disBra){
            System.out.println("### Calculation by WPGMA (Weighted Pair-Group Method with Arithmetic mean) ###");
            System.out.println();
            
            if(output){
                fileWriter("### Calculation by WPGMA (Weighted Pair-Group Method with Arithmetic mean) ###\n", true, hat2Name + ".txt", "UTF-8");
            }
        }
        
        long[][] distMat = new long[numSp][numSp];
        
        for(int i = 0 ; i < numSp ; i++){
            for(int j = 0 ; j < numSp ; j++){
                distMat[i][j] = Long.MAX_VALUE;
            }
        }
        
        for(int i = 0 ; i < listDist.size() ; i++){
            String[] temp = listDist.get(i).split(",");
            
            for(int j = 1 ; j < temp.length ; j++){
                distMat[i][j + i] = (long)(Double.parseDouble(temp[j]) * INDEX_);
            }
        }
        
        String[] noOTU = new String[numSp];
        int numOTU = numSp;
        
        int I = -1;
        int J = -1;
        
        DecimalFormat df4 = new DecimalFormat("0.0000");
        DecimalFormat df3 = new DecimalFormat("00.000");
        DecimalFormat df2 = new DecimalFormat("000.00");
        DecimalFormat df1 = new DecimalFormat("0000.0");
        DecimalFormat df0 = new DecimalFormat("00000");
        
        for(int i = 0 ; i < numSp ; i++){
            if(disName){
                noOTU[i] = listName.get(i);
            }else{
                noOTU[i] = String.valueOf(i + 1);
            }
        }
        
        for(int num = 1 ;; num++){
            long minD = Long.MAX_VALUE;
            I = -1;
            J = -1;
            
            if(disMat || disSum || disBra){
                System.out.println("<< Loop No. " + num + " >>");
                
                if(output){
                    fileWriter("<< Loop No. " + num + " >>", true, hat2Name + ".txt", "UTF-8");
                }
            }
            
            if(disMat){
                System.out.println("* Distance Matrix");
                
                if(output){
                    fileWriter("* Distance Matrix", true, hat2Name + ".txt", "UTF-8");
                }
                
                System.out.print(String.format("%" + order + "s", "  "));
                
                if(output){
                    fileWriter(String.format("%" + order + "s", "  "), false, hat2Name + ".txt", "UTF-8");
                }
                
                for(int j = 1 ; j < numSp ; j++){
                    System.out.print(String.format("%6s", String.valueOf(j + 1)) + " ");
                    
                    if(output){
                        fileWriter(String.format("%6s", String.valueOf(j + 1)) + " ", false, hat2Name + ".txt", "UTF-8");
                    }
                }
                
                System.out.println();
                
                if(output){
                    fileWriter("", true, hat2Name + ".txt", "UTF-8");
                }
                
                for(int i = 0 ; i < numSp - 1 ; i++){
                    System.out.print(String.format("%" + order + "s", String.valueOf(i + 1)) + ":");
                    
                    if(output){
                        fileWriter(String.format("%" + order + "s", String.valueOf(i + 1)) + ":", false, hat2Name + ".txt", "UTF-8");
                    }
                    
                    for(int j = 1 ; j < numSp ; j++){
                        if(distMat[i][j] == Long.MAX_VALUE){
                            if(j > i){
                                System.out.print("______ ");
                                
                                if(output){
                                    fileWriter("______ ", false, hat2Name + ".txt", "UTF-8");
                                }
                            }else{
                                System.out.print("       ");
                                
                                if(output){
                                    fileWriter("       ", false, hat2Name + ".txt", "UTF-8");
                                }
                            }
                        }else{
                            if(distMat[i][j] / INDEX_ < 10){
                                System.out.print(df4.format((double)distMat[i][j] / INDEX_) + " ");
                                
                                if(output){
                                    fileWriter(df4.format((double)distMat[i][j] / INDEX_) + " ", false, hat2Name + ".txt", "UTF-8");
                                }
                            }else if(distMat[i][j] / INDEX_ < 100){
                                System.out.print(df3.format((double)distMat[i][j] / INDEX_) + " ");
                                
                                if(output){
                                    fileWriter(df3.format((double)distMat[i][j] / INDEX_) + " ", false, hat2Name + ".txt", "UTF-8");
                                }
                            }else if(distMat[i][j] / INDEX_ < 1000){
                                System.out.print(df2.format((double)distMat[i][j] / INDEX_) + " ");
                                
                                if(output){
                                    fileWriter(df2.format((double)distMat[i][j] / INDEX_) + " ", false, hat2Name + ".txt", "UTF-8");
                                }
                            }else if(distMat[i][j] / INDEX_ < 10000){
                                System.out.print(df1.format((double)distMat[i][j] / INDEX_) + " ");
                                
                                if(output){
                                    fileWriter(df1.format((double)distMat[i][j] / INDEX_) + " ", false, hat2Name + ".txt", "UTF-8");
                                }
                            }else if(distMat[i][j] / INDEX_ < 100000){
                                System.out.print(" " + df0.format((double)distMat[i][j] / INDEX_) + " ");
                                
                                if(output){
                                    fileWriter(" " + df0.format((double)distMat[i][j] / INDEX_) + " ", false, hat2Name + ".txt", "UTF-8");
                                }
                            }else {
                                System.out.print(((double)distMat[i][j] / INDEX_) + " ");
                                
                                if(output){
                                    fileWriter(((double)distMat[i][j] / INDEX_) + " ", true, hat2Name + ".txt", "UTF-8");
                                }
                            }
                        }
                    }
                    
                    System.out.println();
                    
                    if(output){
                        fileWriter("", true, hat2Name + ".txt", "UTF-8");
                    }
                }
            }
            
            System.out.println();
            
            if(output){
                fileWriter("", true, hat2Name + ".txt", "UTF-8");
            }
            
            for(int i = 0 ; i < numSp - 1 ; i++){
                for(int j = i ; j < numSp ; j++){
                    if(minD > distMat[i][j]){
                        I = i;
                        J = j;
                        minD = distMat[i][j];
                    }
                }
            }
            
            String[] tempI = noOTU[I].split("@");
            String[] tempJ = noOTU[J].split("@");
            
            long eLi = (minD / 2);
            long eLj = (minD / 2);
            
            if(tempI.length != 1){
                eLi -= Long.parseLong(tempI[1]);
            }
            
            if(tempJ.length != 1){
                eLj -= Long.parseLong(tempJ[1]);
            }
            
            noOTU[I] = "(" + tempI[0] + ":" + ((double)eLi / INDEX_) + "," + tempJ[0] + ":" + ((double)eLj / INDEX_) + ")@" + (minD / 2);
            noOTU[J] = "Merged";
            
            if(disBra){
                System.out.println("* Pair of Nodes");
                System.out.println("  i : " + tempI[0]);
                System.out.println("  j : " + tempJ[0]);
                System.out.println("len : " + ((double)(minD / 2) / INDEX_));
                System.out.println("");
                
                if(output){
                    fileWriter("* Pair of Nodes", true, hat2Name + ".txt", "UTF-8");
                    fileWriter("  i : " + tempI[0], true, hat2Name + ".txt", "UTF-8");
                    fileWriter("  j : " + tempJ[0], true, hat2Name + ".txt", "UTF-8");
                    fileWriter("len : " + ((double)(minD / 2) / INDEX_), true, hat2Name + ".txt", "UTF-8");
                    fileWriter("", true, hat2Name + ".txt", "UTF-8");
                }
            }
            
            if(numOTU == 2){
                if(disTree){
                    System.out.println("### Tree Topology (Newick Format) ###");
                    System.out.println();
                    
                    if(output){
                        fileWriter("### Tree Topology (Newick Format) ###", true, hat2Name + ".txt", "UTF-8");
                        fileWriter("", true, hat2Name + ".txt", "UTF-8");
                    }
                    
                    for(int i = 0 ; i < numSp ; i++){
                        if(!noOTU[i].equals("Merged")){
                            String[] temp = noOTU[i].split("@");
                            
                            System.out.println(temp[0] + ";");
                            
                            if(output){
                                fileWriter(temp[0] + ";", true, hat2Name + ".txt", "UTF-8");
                            }
                        }
                    }
                }
                
                break;
            }
            
            long[][] distTmp = new long[numSp][numSp];
            
            for(int i = 0 ; i < numSp ; i++){
                for(int j = 0 ; j < numSp ; j++){
                    distTmp[i][j] = distMat[i][j];
                }
            }
            
            for(int i = 0 ; i < numSp ; i++){
                if(i < I){
                    if(distMat[i][I] != Long.MAX_VALUE){
                        distTmp[i][I] = (distMat[i][I] + distMat[i][J]) / 2;
                    }else{
                        distTmp[i][I] = Long.MAX_VALUE;
                    }
                }else if(i > I){
                    if(J > i){
                        if(distMat[I][i] != Long.MAX_VALUE){
                            distTmp[I][i] = (distMat[I][i] + distMat[i][J]) / 2;
                        }else{
                            distTmp[I][i] = Long.MAX_VALUE;
                        }
                    }else{
                        if(distMat[I][i] != Long.MAX_VALUE){
                            distTmp[I][i] = (distMat[I][i] + distMat[J][i]) / 2;
                        }else{
                            distTmp[I][i] = Long.MAX_VALUE;
                        }
                    }
                }
            }
            
            for(int i = 0 ; i < numSp ; i++){
                for(int j = 0 ; j < numSp ; j++){
                    if(i == J || j == J){
                        distTmp[i][j] = Long.MAX_VALUE;
                    }
                }
            }
            
            for(int i = 0 ; i < numSp ; i++){
                for(int j = 0 ; j < numSp ; j++){
                    distMat[i][j] = distTmp[i][j];
                }
            }
            
            numOTU--;
        }
    }
    
    public static void main(String[] args) {
        MakeWPGMATree dn = new MakeWPGMATree();
        String hat2Name = "";
        boolean disList = true;
        boolean disMat = true;
        boolean disSum = true;
        boolean disBra = true;
        boolean disTree = true;
        boolean disName = true;
        boolean output = false;
        
        boolean judge = true;
        
        if(args[0].equals("-h")){
            System.out.println(" * command");
            System.out.println("  MakeWPGMATree <FileName> <Options>");
            System.out.println(" * option");
            System.out.println("  -O   : Output the result as .txt");
            System.out.println("  -L   : Interfere with showing OTUs list");
            System.out.println("  -T   : Interfere with showing NJ tree");
            System.out.println("  -N   : Display OTU name as number");
            System.out.println("  -d X : Select whether to show progress(Distance matrix, Sums of branch lengthes, and Pair of selected nodes)");
            System.out.println("         X is a three-digit binary number(000 - 111).");
        }else{
            if(args[0].startsWith("-")){
                judge = false;
            }else{
                hat2Name = args[0];
                
                for(int i = 1 ; i < args.length ; i++){
                    if(args[i].equals("-T")){
                        disTree = false;
                    }else if(args[i].equals("-O")){
                        output = true;
                    }else if(args[i].equals("-N")){
                        disName = false;
                    }else if(args[i].equals("-L")){
                        disList = false;
                    }else if(args[i].equals("-d")){
                        if(args[i + 1].startsWith("0") || args[i + 1].startsWith("1")){
                            switch(Integer.parseInt(args[i + 1])){
                                case 0:
                                    break;
                                case 1:
                                    disBra = false;
                                    break;
                                case 10:
                                    disSum = false;
                                    break;
                                case 11:
                                    disSum = false;
                                    disBra = false;
                                    break;
                                case 100:
                                    disMat = false;
                                    break;
                                case 101:
                                    disMat = false;
                                    disBra = false;
                                    break;
                                case 110:
                                    disMat = false;
                                    disSum = false;
                                    break;
                                case 111:
                                    disMat = false;
                                    disSum = false;
                                    disBra = false;
                                    break;
                                default:
                                    judge = false;
                                    break;
                            }
                        }else{
                            judge = false;
                        }
                        
                        i++;
                    }else{
                        judge = false;
                    }
                }
            }
            
            if(judge){
                dn.test(hat2Name, disList, disMat, disSum, disBra, disTree, disName, output);
            }else{
                System.out.println("!!! ERROR !!!");
                System.out.println("Type \"MakeWPGMATree -h\"");
            }
        }
    }
    
}
